% Encoding: UTF-8

@InProceedings{Esterie2012,
  author    = {P. Estérie and M. Gaunard and J. Falcou and J. T. Lapresté and B. Rozoy},
  title     = {Boost.SIMD: Generic programming for portable SIMDization},
  booktitle = {PACT},
  year      = {2012},
  OPTpages  = {431--432},
  OPTmonth  = sep,
  publisher = {IEEE},
  abstract  = {SIMD extensions have been a feature of choice for processor manufacturers for a couple of decades. Designed to exploit data parallelism in applications at the instruction level and provide significant accelerations, these extensions still require a high level of expertise or the use of potentially fragile compiler support or vendor-specific libraries. In this poster, we present Boost.SIMD, a C++ template library that simplifies the exploitation of SIMD hardware within a standard C++ programming model.},
  file      = {:pdf/Esterie2012 - Boost.SIMD\: Generic programming for portable SIMDization.pdf:PDF;:pdf/Esterie2012a - Exploiting Multimedia Extensions in C++\: A Portable Approach.pdf:PDF},
  groups    = {C++, Single Instruction Multiple Data (SIMD), Wrapper},
  keywords  = {C++ language, parallel processing, software libraries, Boost.SIMD, C++ programming model, C++ template library, SIMD hardware, data parallelism, portable SIMDization, C++ languages, Computer architecture, Libraries, Parallel processing, Programming, Registers, Standards, C++, Generic Programming, SIMD, Template Metaprogramming},
}

@Article{Esterie2012a,
  author   = {P. Estérie and others},
  title    = {Exploiting Multimedia Extensions in {C++}: A Portable Approach},
  journal  = {IEEE CS\&E},
  year     = {2012},
  OPTvolume   = {14},
  OPTnumber   = {5},
  OPTpages = {72--77},
  OPTmonth = sep,
  issn     = {1521-9615},
  abstract = {Single instruction, multiple data (SIMD) extensions have been a feature of choice for processor manufacturers for a couple of decades. Designed to provide significant accelerations, they require expertise, the use of potentially fragile compiler support, or vendor-specific libraries. Here, a C++ template library called Boost.SIMD is presented that simplifies the exploitation of SIMD hardware within a standing C++ programming model.},
  doi      = {10.1109/MCSE.2012.96},
  file     = {:pdf/Esterie2012a - Exploiting Multimedia Extensions in C++\: A Portable Approach.pdf:PDF},
  groups   = {C++, Single Instruction Multiple Data (SIMD), Wrapper},
  keywords = {C++ language, multimedia systems, parallel processing, program compilers, software libraries, Boost, C++ programming model, C++ template library, SIMD extensions, SIMD hardware, compiler support, multimedia extensions, single instruction multiple data extensions, vendor-specific libraries, Computational modeling, Hardware, Instruction sets, Programming, Scientific computing, C\&+\&+, SIMD hardware, computational science, scientific computing, scientific programming},
}

@Article{Kretz2012,
  author    = {M. Kretz and V. Lindenstruth},
  title     = {Vc: A {C++} Library for Explicit Vectorization},
  journal   = {Soft.: Practice and Experience},
  year      = {2012},
  OPTvolume    = {42},
  OPTnumber    = {11},
  OPTpages  = {1409--1430},
  doiOPT       = {10.1002/spe.1149},
  file      = {:pdf/Kretz2012 - Vc\: A C++ library for explicit vectorization.pdf:PDF},
  groups    = {Single Instruction Multiple Data (SIMD), C++, Wrapper},
  publisher = {Wiley Online Library},
}

@MastersThesis{Kretz2009,
  author = {M. Kretz},
  title  = {Efficient Use of Multi- and Many-Core Systems with Vectorization and Multithreading},
  school = {University of Heidelberg},
  year   = {2009},
  file   = {:pdf/Kretz2009 - Efficient Use of Multi- and Many-Core Systems with Vectorization and Multithreading.pdf:PDF},
  groups = {Single Instruction Multiple Data (SIMD), C++, Wrapper},
}

@PhdThesis{Kretz2015,
  author   = {M. Kretz},
  title    = {Extending {C++} for Explicit Data-Parallel Programming via {SIMD} Vector Types},
  school   = {Goethe University Frankfurt},
  year     = {2015},
  abstract = {Data-parallel programming is more important than ever since serial performance is stagnating. All mainstream computing architectures have been and are still enhancing their support for general purpose computing with explicitly data-parallel execution. For CPUs, data-parallel execution is implemented via SIMD instructions and registers. GPU hardware works very similar allowing very efficient parallel processing of wide data streams with a common instruction stream.
These advances in parallel hardware have not been accompanied by the necessary advances in established programming languages. Developers have thus not been enabled to explicitly state the data-parallelism inherent in their algorithms. Some approaches of GPU and CPU vendors have introduced new programming languages, language extensions, or dialects enabling explicit data-parallel programming. However, it is arguable whether the programming models introduced by these approaches deliver the best solution. In addition, some of these approaches have shortcomings from a hardware-specific focus of the language design. There are several programming problems for which the aforementioned language approaches are not expressive and flexible enough.
This thesis presents a solution tailored to the C++ programming language. The concepts and interfaces are presented specifically for C++ but as abstract as possible facilitating adoption by other programming languages as well. The approach builds upon the observation that C++ is very expressive in terms of types. Types communicate intention and semantics to developers as well as compilers. It allows developers to clearly state their intentions and allows compilers to optimize via explicitly defined semantics of the type system.
Since data-parallelism affects data structures and algorithms, it is not sufficient to enhance the language's expressivity in only one area. The definition of types whose operators express data-parallel execution automatically enhances the possibilities for building data structures. This thesis therefore defines low-level, but fully portable, arithmetic and mask types required to build a flexible and portable abstraction for data-parallel programming. On top of these, it presents higher-level abstractions such as fixed-width vectors and masks, abstractions for interfacing with containers of scalar types, and an approach for automated vectorization of structured types.
The Vc library is an implementation of these types. I developed the Vc library for researching data-parallel types and as a solution for explicitly data-parallel programming. This thesis discusses a few example applications using the Vc library showing the real-world relevance of the library. The Vc types enable parallelization of search algorithms and data structures in a way unique to this solution. It shows the importance of using the type system for expressing data-parallelism. Vc has also become an important building block in the high energy physics community. Their reliance on Vc shows that the library and its interfaces were developed to production quality.},
  file     = {:pdf/Kretz2015 - Extending C++ for Explicit Data-Parallel Programming via SIMD Vector Types.pdf:PDF},
  groups   = {C++, Single Instruction Multiple Data (SIMD), Wrapper},
  keywords = {C++, SIMD, data parallel, parallel programming, vectorization},
}

@Misc{Kanapickas,
  author   = {P. Kanapickas},
  title    = {libsimdpp},
  year     = {2017},
  abstract = {libsimdpp is a portable header-only zero-overhead C++ wrapper around single-instruction multiple-data (SIMD) intrinsics found in many compilers. The library presents a single interface over several instruction sets in such a way that the same source code may be compiled for different instruction sets. The resulting object files then may be hooked into internal dynamic dispatch mechanism.

The library resolves differences between instruction sets by implementing the missing functionality as a combination of several intrinsics. Moreover, the library supplies a lot of additional, commonly used functionality, such as various variants of matrix transpositions, interleaving loads/stores, optimized compile-time shuffling instructions, etc. Each of these are implemented in the most efficient manner for the target instruction set. Finally, it's possible to fall back to native intrinsics when necessary, without compromising maintanability.

The library sits somewhere in the middle between programming directly in intrinsics and even higher-level SIMD libraries. As much control as possible is given to the developer, so that it's possible to exactly predict what code the compiler will generate.},
  groups   = {Single Instruction Multiple Data (SIMD), C++, Wrapper},
  url      = {https://github.com/p12tic/libsimdpp},
}

@Misc{Mabille,
  author   = {J. Mabille},
  title    = {xsimd},
  year     = {2017},
  abstract = {SIMD (Single Instruction, Multiple Data) is a feature of microprocessors that has been available for many years. SIMD instructions perform a single operation on a batch of values at once, and thus provide a way to significantly accelerate code execution. However, these instructions differ between microprocessor vendors and compilers.

xsimd provides a unified means for using these features for library authors. Namely, it enables manipulation of batches of OPTnumbers with the same arithmetic operators as for single values. It also provides accelerated implementation of common mathematical functions operating on batches.

You can find out more about this implementation of C++ wrappers for SIMD intrinsics at the The C++ Scientist. The mathematical functions are a lightweight implementation of the algorithms used in boost.SIMD.},
  groups   = {Single Instruction Multiple Data (SIMD), C++, Wrapper},
  url      = {https://github.com/JohanMabille/xsimd},
}

@Misc{Cassagne,
  author   = {A. Cassagne},
  title    = {My Intrinsics++ (MIPP)},
  year     = {2017},
  abstract = {MIPP is a portable and Open-source wrapper (MIT license) for vector intrinsic functions (SIMD) written in C++11. It works for SSE, AVX, AVX512 and ARM NEON instructions. MIPP wrapper supports simple/double precision floating-point OPTnumbers and also signed integer arithmetic (32-bit, 16-bit and 8-bit).

With the MIPP wrapper you do not need to write a specific intrinsic code anymore. Just use provided functions and the wrapper will automatically generates the right intrisic calls for your specific architecture.},
  groups   = {Single Instruction Multiple Data (SIMD), Wrapper, C++},
  url      = {https://github.com/aff3ct/MIPP},
}

@Misc{Fog,
  author   = {A. Fog},
  title    = {Vector Class Lib.},
  year     = {2017},
  abstract = {This is a collection of C++ classes, functions and operators that makes it easier to use the the vector instructions (Single Instruction Multiple Data instructions) of modern CPUs without using assembly language. Supports the SSE2, SSE3, SSSE3, SSE4.1, SSE4.2, AVX, AVX2, AVX512, FMA, and XOP instruction sets. Includes standard mathematical functions. Can compile for different instruction sets from the same source code.},
  file     = {:pdf/Fog - C++ Vector Class library (VCL).pdf:PDF},
  groups   = {Wrapper, C++},
  url      = {www.agner.org/optimize/#vectorclass},
}

@InProceedings{Pohl2016,
  author    = {A. Pohl and B. Cosenza and M. A. Mesa and C. C. Chi and B. Juurlink},
  title     = {An Evaluation of Current SIMD Programming Models for {C++}},
  booktitle = {WPMVP},
  year      = {2016},
  OPTpages  = {3:1--3:8},
  address   = {New York, NY, USA},
  publisher = {ACM},
  abstract  = {SIMD extensions were added to microprocessors in the mid '90s to speed-up data-parallel code by vectorization. Unfortunately, the SIMD programming model has barely evolved and the most efficient utilization is still obtained with elaborate intrinsics coding. As a consequence, several approaches to write efficient and portable SIMD code have been proposed. In this work, we evaluate current programming models for the C++ language, which claim to simplify SIMD programming while maintaining high performance.

The proposals were assessed by implementing two kernels: one standard floating-point benchmark and one real-world integer-based application, both highly data parallel. Results show that the proposed solutions perform well for the floating point kernel, achieving close to the maximum possible speed-up. For the real-world application, the programming models exhibit significant performance gaps due to data type issues, missing template support and other problems discussed in this paper.},
  acmid     = {2870653},
  articleno = {3},
  doi       = {10.1145/2870650.2870653},
  file      = {:pdf/Pohl2016 - An Evaluation of Current SIMD Programming Models for C++.pdf:PDF},
  groups    = {Wrapper},
  isbn      = {978-1-4503-4060-1},
  keywords  = {C++, SIMD, parallel programming, programming model, vectorization},
  location  = {Barcelona, Spain},
  numpages  = {8},
  url       = {http://doi.acm.org/10.1145/2870650.2870653},
}

@Misc{OpenMP2013,
  author = {{OpenMP Architecture Review Board}},
  title  = {OpenMP Application Program Interface},
  year   = {2013},
  file   = {:pdf/OpenMP2013 - OpenMP Application Program Interface.pdf:PDF},
  url    = {http://www.openmp.org/mp-documents/OpenMP4.0.0.pdf},
}

@InProceedings{Pharr2012,
  author        = {M. Pharr and W. R. Mark},
  title         = {ispc: A SPMD Compiler for High-Performance {CPU} Programming},
  booktitle     = {InPar},
  year          = {2012},
  OPTpages      = {1--13},
  OPTmonth      = may,
  publisher     = {IEEE},
  abstract      = {SIMD parallelism has become an increasingly important mechanism for delivering performance in modern CPUs, due its power efficiency and relatively low cost in die area compared to other forms of parallelism. Unfortunately, languages and compilers for CPUs have not kept up with the hardware's capabilities. Existing CPU parallel programming models focus primarily on multi-core parallelism, neglecting the substantial computational capabilities that are available in CPU SIMD vector units. GPU-oriented languages like OpenCL support SIMD but lack capabilities needed to achieve maximum efficiency on CPUs and suffer from GPU-driven constraints that impair ease of use on CPUs. We have developed a compiler, the Intel R{\textregistered} SPMD Program Compiler (ispc), that delivers very high performance on CPUs thanks to effective use of both multiple processor cores and SIMD vector units. ispc draws from GPU programming languages, which have shown that for many applications the easiest way to program SIMD units is to use a single-program, multiple-data (SPMD) model, with each instance of the program mapped to one SIMD lane. We discuss language features that make ispc easy to adopt and use productively with existing software systems and show that ispc delivers up to 35x speedups on a 4-core system and up to 240$\times$ speedups on a 40-core system for complex workloads (compared to serial C++ code).},
  doi           = {10.1109/InPar.2012.6339601},
  file          = {:pdf/Pharr2012 - ispc\: A SPMD Compiler for High-Performance CPU Programming.pdf:PDF},
  keywords      = {graphics processing units, multiprocessing systems, parallel programming, program compilers, CPU SIMD vector units, GPU programming languages, GPU-oriented languages, ISPC, Intel R SPMD program compiler, OpenCL, SIMD parallelism, high-performance CPU parallel programming, multicore parallelism, multiple processor cores, single-program multiple-data model, Graphics processing unit, Hardware, Parallel processing, Productivity, Programming, Vectors},
}

@Article{Robison2013,
  author        = {A. D. Robison},
  title         = {Composable Parallel Patterns with Intel Cilk Plus},
  journal       = {IEEE CS\&E},
  year          = {2013},
  OPTvolume        = {15},
  OPTnumber        = {2},
  OPTpages      = {66--71},
  OPTmonth      = mar,
  issn          = {1521-9615},
  abstract      = {Intel Cilk Plus extends C and C++ to enable writing composable deterministic parallel software that can exploit both the thread and vector parallelism commonly available in modern hardware.},
  doi           = {10.1109/MCSE.2013.21},
  file          = {:pdf/Robison2013 - Composable Parallel Patterns with Intel Cilk Plus.pdf:PDF},
  keywords      = {C++ language, multi-threading, C++, Intel Cilk Plus, composable deterministic parallel software, composable parallel pattern, parallel thread, parallel vector, Message systems, Parallel processing, Program processors, Programming, Scientific computing, Vectors, Intel Cilk Plus, OpenMP, parallel programming, scientific programming, thread parallelism, vector parallelism},
}

@Misc{Howes2015,
  author    = {L. Howes},
  title     = {The OpenCL Specification},
  year      = {2015},
  note      = {Version 2.1, Revision 23},
  file      = {:pdf/Howes2015 - The OpenCL Specification.pdf:PDF},
  publisher = {Khronos Group},
  url       = {https://www.khronos.org/registry/OpenCL/specs/opencl-2.1.pdf},
}

@TechReport{Moller2016,
  author      = {R. M\"oller},
  title       = {Design of a Low-Level {C++} Template {SIMD} Library},
  institution = {Bielefeld University, Faculty of Technology, Computer Engineering Group},
  year        = {2016},
  abstract    = {T-SIMD is a low-level C++ template SIMD library which wraps built-in vector data types and built-in vector intrincics in template classes and template functions or overloaded functions, respectively. Templates parameters are the element data type of the vectors and the vector width in bytes (e.g. 16 for SSE* and NEON, 32 for AVX/AVX2). This makes it possible to flexibly change the data type and the vector instruction set for entire portions of the code. SSE*, AVX/AVX2, and ARM NEON vector instruction sets are currently supported.},
  file        = {:pdf/Moller2016 - Design of a Low-Level C++ Template SIMD Library.pdf:PDF},
  groups      = {Wrapper},
  urlOLD         = {http://www.ti.uni-bielefeld.de/html/people/moeller/tsimd_warpingsimd.html},
  url         = {https://goo.gl/po1McY}
}

@Misc{IntelIntrinsicsGuide,
  author   = {{Intel Corp}},
  title    = {Intel Intrinsics Guide},
  year     = {2017},
  abstract = {The Intel Intrinsics Guide is an interactive reference tool for Intel intrinsic instructions, which are C style functions that provide access to many Intel instructions - including Intel® SSE, AVX, AVX-512, and more - without the need to write assembly code.},
  groups   = {Single Instruction Multiple Data (SIMD)},
  url      = {https://software.intel.com/sites/landingpage/IntrinsicsGuide/},
}

@Misc{NeonIntrinsicsGuide,
  author   = {{ARM Ltd}},
  title    = {{NEON} Intrinsics Reference},
  year     = {2017},
  abstract = {The NEON Intrinsics Reference is an interactive reference tool for NEON intrinsic instructions, which are C style functions that provide access to many NEON instructions - including NEON, NEONv2, NEON 64-bit, NEONv2 64-bit, and more - without the need to write assembly code.},
  groups   = {Single Instruction Multiple Data (SIMD)},
  url      = {https://developer.arm.com/technologies/neon/intrinsics},
}

@Misc{AltivecManual,
  author   = {{Freescale Semiconductor}},
  title    = {{AltiVec} Technology Programming Interface Manual},
  year     = {1999},
  abstract = {The primary objective of this manual is to help programmers to provide software that is
compatible across the family of PowerPC processors using AltiVec technology.
To locate any published errata or updates for this document, refer to the website at
http://www.mot.com/SPS/PowerPC/.
This book is one of two that discuss the AltiVec architecture, the two books are:
- AltiVec: The Programming Interface Manual (AltiVec PIM) is used as a reference
guide for high-level programmers. The AltiVec PIM provides a mechanism for
programmers to access AltiVec functionality from programming languages such as
C and C++. The AltiVec PIM defines a programming model for use with the AltiVec
instruction set extension to the PowerPC architecture.
- AltiVec: The Programming Environments Manual (AltiVec PEM) is used as a
reference guide for assembler programmers (or intrinsics). The AltiVec PEM provides a
description for each instruction that includes the instruction format, an
individualized legend that provides such information as the level(s) of the PowerPC
architecture in which the instruction may be found, the privilege level of the
instruction, and figures to help in understanding how the instruction works.
It is beyond the scope of this manual to describe individual AltiVec technology
implementations on PowerPC processors. It must be kept in mind that each PowerPC
processor is unique in its implementation of the AltiVec technology.
The information in this book is subject to change without notice, as described in the
disclaimers on the title page of this book. As with any technical documentation, it is the
readers’ responsibility to be sure they are using the most recent version of the
documentation. For more information, contact your sales representative or visit our website
at: http://www.mot.com/SPS/PowerPC/. },
  groups   = {Single Instruction Multiple Data (SIMD)},
  url      = {https://www.nxp.com/docs/en/reference-manual/ALTIVECPIM.pdf},
}

@Article{Chen2005,
  author        = {J. Chen and A. Dholakia and E. Eleftheriou and M. P. C. Fossorier and X.-Y. Hu},
  title         = {Reduced-Complexity Decoding of {LDPC} Codes},
  journal       = {IEEE TCOM},
  year          = {2005},
  OPTvolume        = {53},
  OPTnumber        = {8},
  OPTpages      = {1288--1299},
  OPTmonth      = aug,
  issn          = {0090-6778},
  abstract      = {Various log-likelihood-ratio-based belief-propagation (LLR-BP) decoding algorithms and their reduced-complexity derivatives for low-density parity-check (LDPC) codes are presented. Numerically accurate representations of the check-node update computation used in LLR-BP decoding are described. Furthermore, approximate representations of the decoding computations are shown to achieve a reduction in complexity by simplifying the check-node update, or symbol-node update, or both. In particular, two main approaches for simplified check-node updates are presented that are based on the so-called min-sum approximation coupled with either a normalization term or an additive offset term. Density evolution is used to analyze the performance of these decoding algorithms, to determine the optimum values of the key parameters, and to evaluate finite quantization effects. Simulation results show that these reduced-complexity decoding algorithms for LDPC codes achieve a performance very close to that of the BP algorithm. The unified treatment of decoding techniques for LDPC codes presented here provides flexibility in selecting the appropriate scheme from performance, latency, computational-complexity, and memory-requirement perspectives.},
  doi           = {10.1109/TCOMM.2005.852852},
  file          = {:pdf/Chen2005 - Reduced-Complexity Decoding of LDPC Codes.pdf:PDF},
  groups        = {LDPC Codes},
  keywords      = {approximation theory, computational complexity, iterative decoding, maximum likelihood decoding, parity check codes, quantisation (signal), LDPC codes, LLR-BP decoding, check-node update, computational-complexity, finite quantization effects, log-likelihood-ratio-based belief-propagation decoding, low-density parity-check codes, memory-requirement perspective, min-sum approximation, reduced-complexity decoding, symbol-node update, Algorithm design and analysis, Approximation algorithms, Computational modeling, Delay, Iterative algorithms, Iterative decoding, Parity check codes, Performance analysis, Quantization, Sum product algorithm, Belief-propagation (BP) decoding, density evolution (DE), iterative decoding, low-density parity-check (LDPC) codes, reduced-complexity decoding, complexity},
}

@Misc{ETSI2017,
  author   = {ETSI},
  title    = {{3GPP}-{TS}38.212 - {Multiplexing} and chan. coding ({R.} 15)},
  OPTmonth = sep,
  year     = {2017},
  groups   = {5G},
}

@Article{Rost2014,
  author   = {P. Rost and others},
  title    = {Cloud Technologies for Flexible {5G} Radio Access Networks},
  journal  = {IEEE Comm. Magazine},
  year     = {2014},
  OPTvolume   = {52},
  OPTnumber   = {5},
  OPTpages = {68--76},
  OPTmonth = may,
  issn     = {0163-6804},
  abstract = {The evolution toward 5G mobile networks will be characterized by an increasing OPTnumber of wireless devices, increasing device and service complexity, and the requirement to access mobile services ubiquitously. Two key enablers will allow the realization of the vision of 5G: very dense deployments and centralized processing. This article discusses the challenges and requirements in the design of 5G mobile networks based on these two key enablers. It discusses how cloud technologies and flexible functionality assignment in radio access networks enable network densification and centralized operation of the radio access network over heterogeneous backhaul networks. The article describes the fundamental concepts, shows how to evolve the 3GPP LTE a},
  doi      = {10.1109/MCOM.2014.6898939},
  file     = {:pdf/Rost2014 - Cloud Technologies for Flexible 5G Radio Access Networks.pdf:PDF},
  groups   = {5G, Cloud-RAN},
  keywords = {Algorithm design and analysis, Computer architecture, Long Term Evolution, Mobile communication, Mobile computing, Protocols, Radio access networks},
}

@TechReport{Ericsson2015,
  author      = {Ericsson},
  title       = {Cloud RAN - The Benefits of Cirtualization, Centralisation and Coordination},
  institution = {Ericsson},
  year        = {2015},
  file        = {:pdf/Ericsson2015 - Cloud RAN - The Benefits of Cirtualization, Centralisation and Coordination.pdf:PDF},
  groups      = {Cloud-RAN},
  url         = {https://www.ericsson.com/assets/local/publications/white-papers/wp-cloud-ran.pdf},
}

@InProceedings{Paul2015,
  author    = {H. Paul and D. Wübben and P. Rost},
  title     = {Implementation and Analysis of Forward Error Correction Decoding for Cloud-{RAN} Systems},
  booktitle = {ICCW},
  year      = {2015},
  OPTpages  = {2708--2713},
  OPTmonth  = jun,
  publisher = {IEEE},
  abstract  = {In future 5G mobile networks, radio access network functions will be virtualized and implemented on centralized cloud platforms. In principle, this allows for more advanced algorithms of joint processing and offers the ability to balance the computational load. However, the shift of functionality on a cloud-platform also imposes challenges on the design of the applied algorithms. In this paper, we analyse the implementation of forward error correction decoding algorithms on general purpose hardware, which draws the main computational burden of signal processing in the uplink. Although the protocol stack introduces strict timing requirements we demonstrate by numerical results the feasibility of such implementation.},
  doi       = {10.1109/ICCW.2015.7247588},
  file      = {:pdf/Paul2015 - Implementation and Analysis of Forward Error Correction Decoding for Cloud-RAN Systems.pdf:PDF},
  groups    = {Cloud-RAN},
  issn      = {2164-7038},
  keywords  = {5G mobile communication, cloud computing, decoding, forward error correction, protocols, radio access networks, signal processing, virtualisation, 5G mobile networks, centralized cloud platforms, cloud-RAN systems, computational load, forward error correction decoding algorithms, protocol stack, radio access network functions, signal processing, Decoding, Forward error correction, Hardware, Mobile communication, Radio access networks, Signal processing algorithms, Signal to noise ratio},
}

@InProceedings{Nikaein2015,
  author    = {N. Nikaein},
  title     = {Processing {RAN} Functions in the Cloud: Critical Issues and Modeling},
  booktitle = {MCS},
  year      = {2015},
  OPTpages  = {36--43},
  publisher = {ACM},
  doi       = {10.1145/2802130.2802136},
  file      = {:pdf/Nikaein2015 - Processing Radio Access Network Functions in the Cloud\: Critical Issues and Modeling.pdf:PDF},
  groups    = {Cloud-RAN},
}

@InProceedings{Rodriguez2017,
  author    = {V. Q. Rodriguez and F. Guillemin},
  title     = {Towards the Deployment of a Fully Centralized Cloud-{RAN} Architecture},
  booktitle = {IWCMC},
  year      = {2017},
  OPTpages  = {1055--1060},
  OPTmonth  = jun,
  publisher = {IEEE},
  abstract  = {In the framework of Network Function Virtualization (NFV), we address in this work the design and sizing of Cloud-RAN architectures. We concretely investigate the execution time of software-based Base Band Units (BBUs) on multi-core systems. Since Cloud-RAN requires a real-time behavior, we use parallel programming techniques in order to minimize the runtime of BBU functions. For an efficient utilization of computing resources, we investigate the relevance of resource pooling where a global scheduling algorithm allocates processing units to runnable BBU-jobs. We specifically examine the gain that can be obtained when applying data parallelism on the channel decoding BBU-function which is the most expensive one in terms of processing time. Performance results show a significant reduction in the runtime of PHY functions which enables the deployment of a fully centralized Cloud-RAN architecture.},
  doi       = {10.1109/IWCMC.2017.7986431},
  file      = {:pdf/Rodriguez2017 - Towards the Deployment of a Fully Centralized Cloud-RAN Architecture.pdf:PDF},
  groups    = {Cloud-RAN},
  keywords  = {channel coding, cloud computing, multiprocessing systems, parallel programming, processor scheduling, radio access networks, telecommunication computing, virtualisation, NFV, PHY functions, channel decoding BBU-function, cloud-RAN architecture, global scheduling algorithm, multicore systems, network function virtualization, parallel programming techniques, software-based base band units, Antennas, Cloud computing, Computer architecture, Decoding, Long Term Evolution, Parallel processing, Runtime, BBU, Cloud-RAN, NFV, VNF, channel decoding, global scheduling, multi-core},
}

@Misc{Gallager1963,
  author = {Robert G. Gallager},
  title  = {Low-Density Parity-Check Codes},
  year   = {1963},
  groups = {LDPC Codes},
}


@Article{MacKay1999,
  author   = {D. J. C. MacKay},
  title    = {Good Error-Correcting Codes based on Very Sparse Matrices},
  journal  = {IEEE TIT},
  year     = {1999},
  OPTvolume   = {45},
  OPTnumber   = {2},
  OPTpages = {399--431},
  OPTmonth = mar,
  issn     = {0018-9448},
  abstract = {We study two families of error-correcting codes defined in terms of very sparse matrices. {\textquotedblleft}MN{\textquotedblright} (MacKay-Neal (1995)) codes are recently invented, and {\textquotedblleft}Gallager codes{\textquotedblright} were first investigated in 1962, but appear to have been largely forgotten, in spite of their excellent properties. The decoding of both codes can be tackled with a practical sum-product algorithm. We prove that these codes are {\textquotedblleft}very good{\textquotedblright}, in that sequences of codes exist which, when optimally decoded, achieve information rates up to the Shannon limit. This result holds not only for the binary-symmetric channel but also for any channel with symmetric stationary ergodic noise. We give experimental results for binary-symmetric channels and Gaussian channels demonstrating that practical performance substantially better than that of standard convolutional and concatenated codes can be achieved; indeed, the performance of Gallager codes is almost as close to the Shannon limit as that of turbo codes},
  doi      = {10.1109/18.748992},
  file     = {:pdf/MacKay1999 - Good Error-Correcting Codes based on Very Sparse Matrices.pdf:PDF},
  groups   = {LDPC Codes},
  keywords = {Gaussian channels, channel coding, decoding, error correction codes, noise, sparse matrices, Gallager codes, Gaussian channels, MacKay-Neal codes, Shannon limit, binary-symmetric channel, channel coding, code sequences, concatenated codes, convolutional codes, decoding, error-correcting codes, information rates, optimally decoded codes, performance, sum-product algorithm, symmetric stationary ergodic noise, turbo codes, very sparse matrices, Code standards, Concatenated codes, Convolutional codes, Decoding, Error correction codes, Gaussian channels, Information rates, Sparse matrices, Sum product algorithm, Turbo codes},
}

@Article{Arikan2009,
  author   = {E. Arikan},
  title    = {Channel Polarization: A Method for Constructing Capacity-Achieving Codes for Symmetric Binary-Input Memoryless Channels},
  journal  = {IEEE TIT},
  year     = {2009},
  OPTvolume   = {55},
  OPTnumber   = {7},
  OPTpages = {3051--3073},
  OPTmonth = jul,
  issn     = {0018-9448},
  abstract = {A method is proposed, called channel polarization, to construct code sequences that achieve the symmetric capacity I(W) of any given binary-input discrete memoryless channel (B-DMC) W. The symmetric capacity is the highest rate achievable subject to using the input letters of the channel with equal probability. Channel polarization refers to the fact that it is possible to synthesize, out of N independent copies of a given B-DMC W, a second set of N binary-input channels {WN(i)1 les i les N} such that, as N becomes large, the fraction of indices i for which I(WN(i)) is near 1 approaches I(W) and the fraction for which I(WN(i)) is near 0 approaches 1-I(W). The polarized channels {WN(i)} are well-conditioned for channel coding: one need only send data at rate 1 through those with capacity near 1 and at rate 0 through the remaining. Codes constructed on the basis of this idea are called polar codes. The paper proves that, given any B-DMC W with I(W) $>$ 0 and any target rate R$<$ I(W) there exists a sequence of polar codes {Cfrn;nges1} such that Cfrn has block-length N=2n , rate ges R, and probability of block error under successive cancellation decoding bounded as Pe(N,R) les O(N-1/4) independently of the code rate. This performance is achievable by encoders and decoders with complexity O(N logN) for each.},
  doi      = {10.1109/TIT.2009.2021379},
  file     = {:pdf/Arikan2009 - Channel Polarization\: A Method for Constructing Capacity-Achieving Codes for Symmetric Binary-Input Memoryless Channels.pdf:PDF},
  groups   = {Polar Codes},
  keywords = {binary codes, channel capacity, channel coding, decoding, memoryless systems, probability, channel capacity, channel coding, channel polarization, code sequence, polar codes, probability, successive cancellation decoding algorithm, symmetric binary-input memoryless channel, Capacity planning, Channel capacity, Channel coding, Codes, Councils, Decoding, Information theory, Memoryless systems, Noise cancellation, Polarization, Capacity-achieving codes, Plotkin construction, Reed-- Muller (RM) codes, channel capacity, channel polarization, polar codes, successive cancellation decoding},
}

@InProceedings{Berrou1993,
  author    = {C. Berrou and A. Glavieux and P. Thitimajshima},
  title     = {Near {Shannon} Limit Error-Correcting Coding and Decoding: Turbo-Codes},
  booktitle = {ICC},
  year      = {1993},
  OPTvolume    = {2},
  OPTpages  = {1064--1070 vol.2},
  OPTmonth  = may,
  publisher = {IEEE},
  abstract  = {A new class of convolutional codes called turbo-codes, whose performances in terms of bit error rate (BER) are close to the Shannon limit, is discussed. The turbo-code encoder is built using a parallel concatenation of two recursive systematic convolutional codes, and the associated decoder, using a feedback decoding rule, is implemented as P pipelined identical elementary decoders},
  file      = {:pdf/Berrou1993 - Near Shannon Limit Error-Correcting Coding and Decoding\: Turbo-Codes.pdf:PDF},
  groups    = {Turbo Codes},
  keywords  = {codecs, concatenated codes, convolutional codes, decoding, error correction codes, error statistics, feedback, pipeline processing, Shannon limit, bit error rate, decoder, encoder, feedback decoding rule, parallel concatenation, pipelined identical elementary decoders, recursive systematic convolutional codes, turbo-codes, Bit error rate, Convolutional codes, Decoding, Digital communication, Digital integrated circuits, Equations, Europe, Feedback, Laboratories, Turbo codes},
}

@Article{LeGal2015,
  author   = {B. {Le Gal} and others},
  title    = {High-Throughput {LDPC} Decoder on Low-Power Embedded Processors},
  journal  = {IEEE COMML},
  year     = {2015},
  OPTvolume   = {19},
  OPTnumber   = {11},
  OPTpages = {1861--1864},
  OPTmonth = nov,
  issn     = {1089-7798},
  abstract = {Real-time efficient implementations of LDPC decoders have long been considered exclusively reachable using dedicated hardware architectures. Attempts to implement LDPC decoders on CPU and GPU devices have lead to high power consumptions as well as high processing latencies that are incompatible with most embedded and mobile transmission systems. In this letter, we propose ARM-based decoders that go from 50 to 100 Mbps while executing 10 layered-decoding iterations. We hereby demonstrate that efficient LDPC decoders can be implemented on a low-power programmable architecture. The proposed decoders are competitive with recent GPU related works. Therefore, software LDPC decoders constitute a response to software defined radio constraints.},
  doi      = {10.1109/LCOMM.2015.2477081},
  file     = {:pdf/LeGal2015 - High-Throughput LDPC Decoder on Low-Power Embedded Processors.pdf:PDF},
  groups   = {LDPC Codes, Software Decoders},
  keywords = {decoding, embedded systems, graphics processing units, low-power electronics, microcontrollers, parity check codes, 10-layered-decoding iterations, ARM-based decoders, CPU devices, GPU devices, hardware architectures, high-throughput LDPC decoder, latencies, low-density parity check code, low-power embedded processors, low-power programmable architecture, Decoding, Graphics processing units, Parity check codes, Power demand, Throughput, ARM processor, LDPC, SIMD, multi-core},
}

@Article{LeGal2016,
  author   = {B. {Le Gal} and C. Jégo},
  title    = {High-Throughput Multi-Core {LDPC} Decoders Based on x86 Processor},
  journal  = {IEEE Transactions on Parallel and Distributed Systems (TPDS)},
  year     = {2016},
  OPTvolume   = {27},
  OPTnumber   = {5},
  OPTpages = {1373--1386},
  OPTmonth = may,
  issn     = {1045-9219},
  abstract = {Low-Density Parity-Check (LDPC) codes are an efficient way to correct transmission errors in digital communication systems. Although initially targeting strictly to ASICs due to computation complexity, LDPC decoders have been recently ported to multicore and many-core systems. Most works focused on taking advantage of GPU devices. In this paper, we propose an alternative solution based on a layered OMS/NMS LDPC decoding algorithm that can be efficiently implemented on a multi-core device using Single Instruction Multiple Data (SIMD) and Single Program Multiple Data (SPMD) programming models. Several experimentations were performed on a x86 processor target. Throughputs up to 170 Mbps were achieved on a single core of an INTEL Core i7 processor when executing 20 layered-based decoding iterations. Throughputs reaches up to 560 Mbps on four INTEL Core-i7 cores. Experimentation results show that the proposed implementations achieved similar BER correction performance than previous works. Moreover, much higher throughputs have been achieved by comparison with all previous GPU and CPU works. They range from x1.4 to x8 by comparison with recent GPU works.},
  doi      = {10.1109/TPDS.2015.2435787},
  file     = {:pdf/LeGal2016 - High-Throughput Multi-Core LDPC Decoders Based on x86 Processor.pdf:PDF},
  groups   = {LDPC Codes, Software Decoders, HoF LDPC - BP},
  keywords = {application specific integrated circuits, decoding, error statistics, microprocessor chips, multiprocessing systems, parity check codes, 20 layered-based decoding iterations, ASIC, BER correction, INTEL Core i7 processor, SIMD, SPMD, computation complexity, digital communication systems, high-throughput multicore LDPC decoders, layered OMS-NMS LDPC decoding, low-density parity-check codes, many-core systems, multicore device, normalized min-sum, offset min-sum, single instruction multiple data, single program multiple data, transmission errors, x86 processor, Decoding, Graphics processing units, Iterative decoding, Processor scheduling, Throughput, GPU, LDPC decoding, SIMD architecture, Software Define Radio (SDR), software decoders, software define radio (SDR), throughput, x86 processor},
}

@Article{Giard2016b,
  author    = {P. Giard and G. Sarkis and C. Leroux and C. Thibeault and W. J. Gross},
  title     = {Low-Latency Software Polar Decoders},
  journal   = {JSPS},
  year      = {2016},
  OPTpages  = {1},
  OPTmonth  = jul,
  abstract  = {Polar codes are a new class of capacity-achieving error-correcting codes with low encoding and decoding complexity. Their low-complexity decoding algorithms rendering them attractive for use in software-defined radio applications where computational resources are limited. In this work, we present low-latency software polar decoders that exploit modern processor capabilities. We show how adapting the algorithm at various levels can lead to significant improvements in latency and throughput, yielding polar decoders that are suitable for high-performance software-defined radio applications on modern desktop processors and embedded-platform processors. These proposed decoders have an order of magnitude lower latency and memory footprint compared to state-of-the-art decoders, while maintaining comparable throughput. In addition, we present strategies and results for implementing polar decoders on graphical processing units. Finally, we show that the energy efficiency of the proposed decoders is comparable to state-of-the-art software polar decoders.},
  date      = {2016-07-11},
  doi       = {10.1007/s11265-016-1157-y},
  file      = {:pdf/Giard2016b - Low-Latency Software Polar Decoders.pdf:PDF},
  groups    = {Polar Codes, Software Decoders, HoF Polar - SC},
  publisher = {Springer},
  url       = {http://dx.doi.org/10.1007/s11265-016-1157-y},
}

@Article{Sarkis2016,
  author   = {G. Sarkis and P. Giard and A. Vardy and C. Thibeault and W. J. Gross},
  title    = {Fast List Decoders for Polar Codes},
  journal  = {IEEE Journal on Selected Areas in Communications (JSAC)},
  year     = {2016},
  OPTvolume   = {34},
  OPTnumber   = {2},
  OPTpages = {318--328},
  OPTmonth = feb,
  issn     = {0733-8716},
  abstract = {Polar codes asymptotically achieve the symmetric capacity of memoryless channels, yet their error-correcting performance under successive-cancellation (SC) decoding for short and moderate length codes is worse than that of other modern codes such as low-density parity-check (LDPC) codes. Of the many methods to improve the error-correction performance of polar codes, list decoding yields the best results, especially when the polar code is concatenated with a cyclic redundancy check (CRC). List decoding involves exploring several decoding paths with SC decoding, and therefore tends to be slower than SC decoding itself, by an order of magnitude in practical implementations. In this paper, we present a new algorithm based on unrolling the decoding tree of the code that improves the speed of list decoding by an order of magnitude when implemented in software. Furthermore, we show that for software-defined radio applications, our proposed algorithm is faster than the fastest software implementations of LDPC decoders in the literature while offering comparable error-correction performance at similar or shorter code lengths.},
  doi      = {10.1109/JSAC.2015.2504299},
  file     = {:pdf/Sarkis2016 - Fast List Decoders for Polar Codes.pdf:PDF;:pdf/Sarkis2016a - Flexible and Low-Complexity Encoding and Decoding of Systematic Polar Codes.pdf:PDF},
  groups   = {Polar Codes, Software Decoders, HoF Polar - SCL},
  keywords = {cyclic redundancy check codes, parity check codes, software radio, LDPC codes, cyclic redundancy check, fast list decoders, low-density parity-check codes, memoryless channels, polar codes, software-defined radio, successive-cancellation decoding, symmetric capacity, Complexity theory, Decoding, Hardware, Parity check codes, Reliability, Software, Software algorithms, LDPC, list decoding, polar codes, software decoders, software-defined radio},
}

@InProceedings{Cassagne2016,
  author     = {A. Cassagne and B. {Le Gal} and C. Leroux and O. Aumage and D. Barthou},
  title      = {An Efficient, Portable and Generic Library for Successive Cancellation Decoding of Polar Codes},
  booktitle  = {LCPC},
  year       = {2016},
  OPTmonth   = jan,
  publisher  = {Springer},
  abstract   = {Error Correction Code decoding algorithms for consumer products such as Internet of Things (IoT) devices are usually implemented as dedicated hardware circuits. As processors are becoming increasingly powerful and energy efficient, there is now a strong desire to perform this processing in software to reduce production costs and time to market. The recently introduced family of Successive Cancellation decoders for Polar codes has been shown in several research works to efficiently leverage the ubiquitous SIMD units in modern CPUs, while offering strong potentials for a wide range of optimizations. The P-EDGE environment introduced in this paper, combines a specialized skeleton generator and a building blocks library routines to provide a generic, extensible Polar code exploration workbench. It enables ECC code designers to easily experiments with combinations of existing and new optimizations, while delivering performance close to state-of-art decoders.},
  date       = {2016-01-01},
  doi        = {10.1007/978-3-319-29778-1_19},
  file       = {:pdf/Cassagne2016 - An Efficient, Portable and Generic Library for Successive Cancellation Decoding of Polar Codes.pdf:PDF},
  groups     = {Polar Codes, Software Decoders, HoF Polar - SC},
  OPTjournal = {Languages and Compilers for Parallel Computing},
  url        = {http://dx.doi.org/10.1007/978-3-319-29778-1_19},
}

@InProceedings{Cassagne2016b,
  author    = {A. Cassagne and O. Aumage and C. Leroux and D. Barthou and B. {Le Gal}},
  title     = {Energy Consumption Analysis of Software Polar Decoders on Low Power Processors},
  booktitle = {EUSIPCO},
  year      = {2016},
  OPTpages  = {642--646},
  OPTmonth  = aug,
  publisher = {IEEE},
  abstract  = {This paper presents a new dynamic and fully generic implementation of a Successive Cancellation (SC) decoder (multi-precision support and intra-/inter-frame strategy support). This fully generic SC decoder is used to perform comparisons of the different configurations in terms of throughput, latency and energy consumption. A special emphasis is given on the energy consumption on low power embedded processors for software defined radio (SDR) systems. A N=4096 code length, rate 1/2 software SC decoder consumes only 14 nJ per bit on an ARM Cortex-A57 core, while achieving 65 Mbps. Some design guidelines are given in order to adapt the configuration to the application context.},
  doi       = {10.1109/EUSIPCO.2016.7760327},
  file      = {:pdf/Cassagne2016b - Energy Consumption Analysis of Software Polar Decoders on Low Power Processors.pdf:PDF},
  groups    = {Polar Codes, Software Decoders, HoF Polar - SC},
  keywords  = {decoding, energy consumption, software radio, telecommunication power management, ARM Cortex-A57, SC decoder implementation, SDR system, low power embedded processor, software defined radio system, software polar decoder energy consumption analysis, successive cancellation decoder implementation, Bit error rate, Decoding, Encoding, Energy consumption, Program processors, Throughput},
}

@InProceedings{Zhang2012,
  author    = {Suiping Zhang and Rongrong Qian and Tao Peng and Ran Duan and Kuilin Chen},
  title     = {High Throughput Turbo Decoder Design for {GPP} Platform},
  booktitle = {CHINACOM},
  year      = {2012},
  OPTpages  = {817--821},
  OPTmonth  = aug,
  publisher = {IEEE},
  abstract  = {The great development of general-purpose processor technology makes the GPP possess the efficiently massive data processing abilities. In the solution(s) of 3GPP LTE system based on GPP platform, Turbo decoding algorithms play a vital role for high decoding complexity. This paper presents the design and implementation of SIMD technique based parallel turbo decoder suitable for GPP architecture. We improve the throughput through a) adopting fix-point design, b) taking full advantage of SIMD technique, c) using multiple soft-input soft-output decoders that operate in parallel, d) introducing multi-core technique to parallelize workload across cores. With 4 threads, the throughput of our SIMD and multi-threading technology based turbo decoder for GPP platform achieves 150 Mbps which can meet the requirement of LTE system.},
  doi       = {10.1109/ChinaCom.2012.6417597},
  file      = {:pdf/Zhang2012 - High Throughput Turbo Decoder Design for GPP Platform.pdf:PDF},
  groups    = {Turbo Codes, Software Decoders, HoF Turbo - MAP},
  keywords  = {3G mobile communication, Long Term Evolution, codecs, multi-threading, parallel processing, turbo codes, 3GPP LTE system, GPP platform, SIMD technique, general-purpose processor technology, massive data processing, multi-threading technology, turbo decoder design, turbo decoding algorithms, Approximation algorithms, Complexity theory, Computer architecture, Decoding, Signal processing, Throughput, Wireless communication, GPP, LTE, SIMD, multi-thread, turbo decoder},
}

@InProceedings{Wu2013,
  author    = {M. Wu and others},
  title     = {{HSPA+/LTE-A} Turbo Decoder on {GPU} and Multicore {CPU}},
  booktitle = {ACSSC},
  year      = {2013},
  OPTpages  = {824--828},
  OPTmonth  = nov,
  publisher = {IEEE},
  abstract  = {This paper compares two implementations of reconfigurable and high-throughput turbo decoders. The first implementation is optimized for an NVIDIA Kepler graphics processing unit (GPU), whereas the second implementation is for an Intel Ivy Bridge processor. Both implementations support max-log-MAP and log-MAP turbo decoding algorithms, various code rates, different interleaver types, and all block-lengths, as specified by HSPA; and LTE-Advanced. In order to ensure a fair comparison between both implementations, we perform device-specific optimizations to improve the decoding throughput and error-rate performance. Our results show that the Intel Ivy Bridge processor implementation achieves up to 2$\times$ higher decoding throughput than our GPU implementation. In addition our CPU implementation requires roughly 4$\times$ fewer codewords to be processed in parallel to achieve its peak throughput.},
  doi       = {10.1109/ACSSC.2013.6810402},
  file      = {:pdf/Wu2013 - HSPA+ LTE-A Turbo Decoder on GPU and Multicore CPU.pdf:PDF},
  groups    = {Turbo Codes, Software Decoders, HoF Turbo - MAP},
  keywords  = {Long Term Evolution, graphics processing units, maximum likelihood decoding, multiprocessing systems, turbo codes, GPU, HSPA, Intel Ivy Bridge processor, LTE-Advanced, NVIDIA Kepler graphics processing unit, block-lengths, code rates, decoding throughput, device-specific optimizations, error-rate performance, high-throughput turbo decoders, interleaver types, log-MAP turbo decoding algorithms, max-log-MAP algorithms, multicore CPU, reconfigurable turbo decoders, Approximation methods, Decoding, Graphics processing units, Measurement, Throughput, Turbo codes, Vectors},
}

@InProceedings{Cassagne2016a,
  author    = {A. Cassagne and others},
  title     = {Beyond {G}bps Turbo Decoder on Multi-Core {CPUs}},
  booktitle = {International Symposium on Turbo Codes and Iterative Information Processing (ISTC)},
  year      = {2016},
  OPTpages  = {136--140},
  OPTmonth  = sep,
  publisher = {IEEE},
  abstract  = {This paper presents a high-throughput implementation of a portable software turbo decoder. The code is optimized for traditional multi-core CPUs (like x86) and it is based on the Enhanced max-log-MAP turbo decoding variant. The code follows the LTE-Advanced specification. The key of the high performance comes from an inter-frame SIMD strategy combined with a fixed-point representation. Our results show that proposed multi-core CPU implementation of turbo-decoders is a challenging alternative to GPU implementation in terms of throughput and energy efficiency. On a high-end processor, our software turbo-decoder exceeds 1 Gbps information throughput for all rate-1/3 LTE codes with K $<$; 4096.},
  doi       = {10.1109/ISTC.2016.7593092},
  file      = {:pdf/Cassagne2016a - Beyond Gbps Turbo Decoder on Multi-Core CPUs.pdf:PDF},
  groups    = {Turbo Codes, Software Decoders, HoF Turbo - MAP},
  keywords  = {codecs, maximum likelihood decoding, microprocessor chips, turbo codes, Gbps turbo decoder, energy efficiency, enhanced max-log-MAP turbo decoding variant, inter-frame SIMD strategy, multicore CPU, portable software turbo decoder, rate-l/3 LTE codes, Instruction sets, Measurement},
}

@Article{Box1958,
  author    = {G. E. P. Box and M. E. Muller and others},
  title     = {A Note on the Generation of Random Normal Deviates},
  journal   = {The Annals of Mathematical Statistics},
  year      = {1958},
  OPTvolume    = {29},
  OPTnumber    = {2},
  OPTpages  = {610--611},
  file      = {:pdf/Box1958 - A Note on the Generation of Random Normal Deviates.pdf:PDF},
  groups    = {Pseudo-Random Number Generator (PRNG)},
  keywords  = {Box-Muller, Box, Muller},
  publisher = {Institute of Mathematical Statistics},
}

@InProceedings{Giard2014,
  author    = {P. Giard and G. Sarkis and C. Thibeault and W. J. Gross},
  title     = {Fast Software Polar Decoders},
  booktitle = {ICASSP},
  year      = {2014},
  OPTpages  = {7555--7559},
  OPTmonth  = may,
  publisher = {IEEE},
  abstract  = {Among error-correcting codes, polar codes are the first to provably achieve channel capacity with an explicit construction. In this work, we present software implementations of a polar decoder that leverage the capabilities of modern general-purpose processors to achieve an information throughput in excess of 200 Mbps, a throughput well suited for software-defined-radio applications. We also show that, for a similar error-correction performance, the throughput of polar decoders both surpasses that of LDPC decoders targeting general-purpose processors and is competitive with that of state-of-the-art software LDPC decoders running on graphic processing units.},
  doi       = {10.1109/ICASSP.2014.6855069},
  file      = {:pdf/Giard2014 - Fast Software Polar Decoders.pdf:PDF},
  groups    = {Polar Codes, Software Decoders, HoF Polar - SC},
  issn      = {1520-6149},
  keywords  = {channel capacity, codecs, error correction codes, graphics processing units, parity check codes, software radio, channel capacity, error-correcting codes, error-correction performance, general-purpose processors, graphic processing units, information throughput, polar codes, software LDPC decoders, software implementations, software polar decoders, software-defined-radio applications, Decoding, Graphics processing units, Hardware, Parity check codes, Signal processing algorithms, Throughput, Decoding, Error-Correction, Polar Codes, Software-Defined-Radio},
}

@Article{Stephens2017,
  author    = {N. Stephens and others},
  title     = {The {ARM} Scalable Vector Extension},
  journal   = {IEEE Micro},
  year      = {2017},
  OPTvolume = {37},
  OTPnumber = {2},
  OTPpages  = {26--39},
  OTPmonth  = mar,
  issn      = {0272-1732},
  abstract  = {This article describes the ARM Scalable Vector Extension (SVE). Several goals guided the design of the architecture. First was the need to extend the vector processing capability associated with the ARM AArch64 execution state to better address the computational requirements in domains such as high-performance computing, data analytics, computer vision, and machine learning. Second was the desire to introduce an extension that can scale across multiple implementations, both now and into the future, allowing CPU designers to choose the vector length most suitable for their power, performance, and area targets. Finally, the architecture should avoid imposing a software development cost as the vector length changes and where possible reduce it by improving the reach of compiler auto-vectorization technologies. SVE achieves these goals. It allows implementations to choose a vector register length between 128 and 2,048 bits. It supports a vector-length agnostic programming model that lets code run and scale automatically across all vector lengths without recompilation. Finally, it introduces several innovative features that begin to overcome some of the traditional barriers to autovectorization.},
  doi       = {10.1109/MM.2017.35},
  file      = {:pdf/Stephens2017 - The ARM Scalable Vector Extension (bis).pdf:PDF},
  groups    = {Error-Correcting Codes (ECC), Single Instruction Multiple Data (SIMD)},
  keywords  = {program compilers, programming, vectors, ARM AArch64 execution state, ARM scalable vector extension, CPU designers, SVE, area targets, compiler autovectorization technologies, computational requirements, computer vision, data analytics, high-performance computing, machine learning, performance targets, power targets, vector length, vector processing capability, vector-length agnostic programming model, Computer architecture, Encoding, High performance computing, Programming, Scalability, Software engineering, Vectors, ARM, HPC, SIMD, SVE, Scalable Vector Extension, VLA, Vector Length Agnostic, autovectorization, data parallelism, high-performance computing, instruction set architecture, predication, scalable vector architecture, vector length agnostic},
}

@Comment{jabref-meta: databaseType:bibtex;}

@Comment{jabref-meta: grouping:
0 AllEntriesGroup:;
1 StaticGroup:Error-Correcting Codes (ECC)\;2\;1\;\;\;\;;
2 StaticGroup:Software Decoders\;0\;1\;\;\;\;;
2 StaticGroup:Hardware Decoders\;0\;1\;\;\;\;;
2 StaticGroup:Polar Codes\;0\;1\;\;\;\;;
2 StaticGroup:Turbo Codes\;0\;1\;\;\;\;;
2 StaticGroup:LDPC Codes\;0\;1\;\;\;\;;
2 StaticGroup:HoF Software Decoders\;2\;0\;\;\;Hall of Fame for Software Decoders\;;
3 StaticGroup:HoF Polar\;2\;1\;\;\;\;;
4 StaticGroup:HoF Polar - SC\;0\;1\;\;\;\;;
4 StaticGroup:HoF Polar - SCAN\;0\;1\;\;\;\;;
4 StaticGroup:HoF Polar - SCL\;0\;1\;\;\;\;;
3 StaticGroup:HoF LDPC\;2\;1\;\;\;\;;
4 StaticGroup:HoF LDPC - BP\;0\;1\;\;\;\;;
4 StaticGroup:HoF LDPC - LP\;0\;1\;\;\;\;;
3 StaticGroup:HoF Turbo\;2\;1\;\;\;\;;
4 StaticGroup:HoF Turbo - MAP\;0\;1\;\;\;\;;
1 StaticGroup:Single Instruction Multiple Data (SIMD)\;2\;1\;\;\;\;;
2 StaticGroup:Sort\;2\;1\;\;\;\;;
2 StaticGroup:Wrapper\;2\;1\;\;\;\;;
2 StaticGroup:Kernel\;2\;1\;\;\;\;;
1 StaticGroup:C++\;0\;1\;\;\;\;;
1 StaticGroup:Pseudo-Random Number Generator (PRNG)\;2\;1\;\;\;\;;
1 StaticGroup:Factor Graphs\;2\;1\;\;\;\;;
1 StaticGroup:Cloud-RAN\;0\;1\;\;\;\;;
1 StaticGroup:Software Defined Radio (SDR)\;2\;1\;\;\;\;;
1 StaticGroup:Standards\;2\;1\;\;\;\;;
2 StaticGroup:4G\;0\;1\;\;\;\;;
2 StaticGroup:5G\;0\;1\;\;\;\;;
2 StaticGroup:DVB\;2\;1\;\;\;\;;
}
